<template>
  <div>
    <div class="row">
      <div class="col-xs-12">
        <p class="add-subscription-title">О заказах на какие услуги вас уведомлять</p>
      </div>
    </div>
    <div
      v-for="service in allServices"
      :key="service.uuid"
      class="row"
    >
      <div class="col-xs-12">
        <ob-select
          ref="services"
          :label="service.title"
          placeholder="-"
          :items="groupedList(service.list)"
          :value="valuesServices(service)"
          :is-dropdown="true"
          :isAutoComplete="true"
          data-qa="selectedServices"
          @input="servicesChanged($event, service)"
          @selected="selected($event, service)"
        />
      </div>
    </div>

  </div>
</template>

<script>
import ObSelect from 'common-components/src/obComponents/obSelect';
import { mapGetters } from 'vuex';
import cloneDeep from 'clone-deep'

export default {
  name: 'SubscriptionModalServices',
  components: {
    ObSelect
  },
  props: {
    serviceList: {
      type: Array
    }
  },
  computed: {
    ...mapGetters({
      allServices: 'subscriptions/services',
    })
  },
  methods: {
    groupedList (list) {
      const resourceSubtypeUuids = Array.from(new Set(list.map(item => item.resourceSubtypeUuid)))

      return resourceSubtypeUuids.reduce((acc, uuid) => {
        const groupTitle = list.find(item => item.resourceSubtypeUuid === uuid).resourceSubtypeTitle
        return acc.concat([
          {
            title: groupTitle,
            children: list.filter(item => item.resourceSubtypeUuid === uuid)
          }
        ])
      }, [])
    },
    servicesChanged (listUuid, service) {
      let clonedServiceList = cloneDeep(this.serviceList);
      if (listUuid.length) {
        const filterServices = this.allServices.reduce((acc, item) => acc.concat(item.list) ,[]).filter(item => listUuid.includes(item.uuid));
        const isAll = service?.list?.length === listUuid.length
        const resourceSubtypeUuids = isAll ? [] : Array.from(new Set(filterServices.map(item => item.resourceSubtypeUuid)));
        const serviceUuids = isAll ? [] : filterServices.map(item => item.uuid);

        let flag = clonedServiceList.find(key => key.serviceTypeUuid === service.uuid);
        if (flag) {
          flag.isAll = isAll;
          if(flag.isAll){
            flag.resourceSubtypeUuids = [];
            flag.serviceUuids = [];
          } else{
            flag.resourceSubtypeUuids = resourceSubtypeUuids;
            flag.serviceUuids = serviceUuids;
          }
        } else {
          let data = {
            serviceTypeUuid: service.uuid,
            isAll,
            resourceSubtypeUuids,
            serviceUuids
          };
          clonedServiceList.push(data);
        }
      } else {
        let index = clonedServiceList.findIndex(key => key.serviceTypeUuid === service.uuid);
        if (index !== -1) {
          clonedServiceList.splice(index, 1);
        }
      }
      this.$emit('setServices', clonedServiceList)
    },
    valuesServices (value) {
      const service = this.serviceList?.find(key => key.serviceTypeUuid === value.uuid);
      if (service) {
        if (!service.isAll) return service.serviceUuids;

        const serviceFromStore = this.allServices.find(key => key.uuid === service.serviceTypeUuid)

        return serviceFromStore.list.map(k => k.uuid)
      }
    },
  }
};
</script>
